diff --git a/langtools/src/share/classes/com/sun/tools/javac/comp/Check.java b/langtools/src/share/classes/com/sun/tools/javac/comp/Check.java
index 09cddea..e169d2a 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/comp/Check.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/comp/Check.java
@@ -25,25 +25,24 @@
 
 package com.sun.tools.javac.comp;
 
-import java.util.*;
-import java.util.Set;
+import static com.sun.tools.javac.code.Flags.*;
+import static com.sun.tools.javac.code.Kinds.*;
+import static com.sun.tools.javac.code.TypeTags.*;
 
 import com.sun.tools.javac.code.*;
+import com.sun.tools.javac.code.Attribute.Compound;
+import com.sun.tools.javac.code.Flags.Flag;
+import com.sun.tools.javac.code.Lint.LintCategory;
+import com.sun.tools.javac.code.Symbol.*;
+import com.sun.tools.javac.code.Type.*;
 import com.sun.tools.javac.jvm.*;
 import com.sun.tools.javac.tree.*;
+import com.sun.tools.javac.tree.JCTree.*;
 import com.sun.tools.javac.util.*;
-import com.sun.tools.javac.util.JCDiagnostic.DiagnosticPosition;
 import com.sun.tools.javac.util.List;
+import com.sun.tools.javac.util.JCDiagnostic.DiagnosticPosition;
 
-import com.sun.tools.javac.tree.JCTree.*;
-import com.sun.tools.javac.code.Lint;
-import com.sun.tools.javac.code.Lint.LintCategory;
-import com.sun.tools.javac.code.Type.*;
-import com.sun.tools.javac.code.Symbol.*;
-
-import static com.sun.tools.javac.code.Flags.*;
-import static com.sun.tools.javac.code.Kinds.*;
-import static com.sun.tools.javac.code.TypeTags.*;
+import java.util.*;
 
 /** Type checking helper class for the attribution phase.
  *
@@ -914,7 +913,7 @@ public class Check {
                                           types.capture(tree.type).allparams());
                 while (args.nonEmpty() && tvars_cap.nonEmpty()) {
                     // Let the actual arguments know their bound
-                    args.head.type.withTypeVar((TypeVar)tvars_cap.head);
+                    args.head.type.withTypeVar(tvars_cap.head);
                     args = args.tail;
                     tvars_cap = tvars_cap.tail;
                 }
@@ -1332,7 +1331,7 @@ public class Check {
             Type st = types.supertype(origin.type);
             if (st.tag != CLASS)
                 return true;
-            MethodSymbol stimpl = m.implementation((ClassSymbol)st.tsym, types, false);
+            MethodSymbol stimpl = m.implementation(st.tsym, types, false);
 
             if (mc != null && ((mc.flags() & INTERFACE) != 0)) {
                 List<Type> intfs = types.interfaces(origin.type);
@@ -1858,25 +1857,25 @@ public class Check {
  * Check annotations
  **************************************************************************/
 
-    /** Annotation types are restricted to primitives, String, an
+    /** Annotation constants are restricted to primitives, String, an
      *  enum, an annotation, Class, Class<?>, Class<? extends
      *  Anything>, arrays of the preceding.
      */
-    void validateAnnotationType(JCTree restype) {
-        // restype may be null if an error occurred, so don't bother validating it
-        if (restype != null) {
-            validateAnnotationType(restype.pos(), restype.type);
-        }
+    void validateAnnotationTypeAsConstant(JCTree restype) {
+    // restype may be null if an error occurred, so don't bother validating it
+     if (restype != null) {
+	 validateAnnotationTypeAsConstant(restype.pos(), restype.type);
+     }
     }
 
-    void validateAnnotationType(DiagnosticPosition pos, Type type) {
+    void validateAnnotationTypeAsConstant(DiagnosticPosition pos, Type type) {
         if (type.isPrimitive()) return;
         if (types.isSameType(type, syms.stringType)) return;
         if ((type.tsym.flags() & Flags.ENUM) != 0) return;
         if ((type.tsym.flags() & Flags.ANNOTATION) != 0) return;
         if (types.lowerBound(type).tsym == syms.classType.tsym) return;
         if (types.isArray(type) && !types.isArray(types.elemtype(type))) {
-            validateAnnotationType(pos, types.elemtype(type));
+            validateAnnotationTypeAsConstant(pos, types.elemtype(type));
             return;
         }
         log.error(pos, "invalid.annotation.member.type");
@@ -1889,6 +1888,9 @@ public class Check {
      * or in the interface annotation.Annotation."
      *
      * @jls3 9.6 Annotation Types
+     * 
+     * Additionally: disallows @AllowNonConstant for methods that
+     * are of array types.  (Not yet specced.)
      */
     void validateAnnotationMethod(DiagnosticPosition pos, MethodSymbol m) {
         for (Type sup = syms.annotationType; sup.tag == CLASS; sup = types.supertype(sup)) {
@@ -1900,19 +1902,39 @@ public class Check {
                     log.error(pos, "intf.annotation.member.clash", e.sym, sup);
             }
         }
+        
+        if (m.getReturnType() instanceof ArrayType
+		&& m.attribute(syms.annotationAllowNonConstant.tsym) != null) {
+	    log.error(pos,
+		    "annotation.array.types.always.constant");
+	}
     }
 
     /** Check the annotations of a symbol.
      */
-    public void validateAnnotations(List<JCAnnotation> annotations, Symbol s) {
+    public void validateAnnotations(List<JCAnnotation> annotations, Symbol s, Env<AttrContext> env) {
         if (skipAnnotations) return;
         for (JCAnnotation a : annotations)
             validateAnnotation(a, s);
+
+        for (Compound attrib : s.getAnnotationMirrors()) {
+            for (Pair<MethodSymbol, Attribute> value : attrib.values) {
+		if (value.snd instanceof Attribute.Expression
+			&& value.fst
+				.attribute(syms.annotationAllowNonConstant.tsym) == null) {
+		    log.error(
+			    (((Attribute.Expression) value.snd)
+				    .getValue()).pos,
+			    "attribute.value.must.be.constant");
+		}
+	    }
+        }
     }
 
     /** Check the type annotations
      */
-    public void validateTypeAnnotations(List<JCTypeAnnotation> annotations, boolean isTypeParameter) {
+    public void validateTypeAnnotations(List<JCTypeAnnotation> annotations, boolean isTypeParameter,
+        Env<AttrContext> env) {
         if (skipAnnotations) return;
         for (JCTypeAnnotation a : annotations)
             validateTypeAnnotation(a, isTypeParameter);
diff --git a/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassFile.java b/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassFile.java
index c560ccb..cef4684 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassFile.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassFile.java
@@ -81,6 +81,19 @@ public class ClassFile {
     public final static int CONSTANT_InterfaceMethodref = 11;
     public final static int CONSTANT_NameandType = 12;
 
+    public final static int TREE_ArrayAccess = 1;
+    public final static int TREE_Binary = 2;
+    public final static int TREE_Conditional = 3;
+    public final static int TREE_FieldAccess = 4;
+    public final static int TREE_Ident = 5;
+    public final static int TREE_InstanceOf = 6;
+    public final static int TREE_Literal = 7;
+    public final static int TREE_MethodInvocation = 8;
+    public final static int TREE_NewArray = 9;
+    public final static int TREE_NewClass = 10;
+    public final static int TREE_TypeCast = 11;
+    public final static int TREE_Unary = 12;
+
     public final static int MAX_PARAMETERS = 0xff;
     public final static int MAX_DIMENSIONS = 0xff;
     public final static int MAX_CODE = 0xffff;
@@ -159,14 +172,16 @@ public class ClassFile {
             this.type = type;
         }
 
-        public boolean equals(Object other) {
+        @Override
+	public boolean equals(Object other) {
             return
                 other instanceof NameAndType &&
                 name == ((NameAndType) other).name &&
                 type.equals(((NameAndType) other).type);
         }
 
-        public int hashCode() {
+        @Override
+	public int hashCode() {
             return name.hashCode() * type.hashCode();
         }
     }
diff --git a/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassReader.java b/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassReader.java
index 4fef653..fd3a063 100644
--- a/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassReader.java
+++ b/langtools/src/share/classes/com/sun/tools/javac/jvm/ClassReader.java
@@ -25,34 +25,32 @@
 
 package com.sun.tools.javac.jvm;
 
-import java.io.*;
-import java.net.URI;
-import java.nio.CharBuffer;
-import java.util.EnumSet;
-import java.util.HashMap;
-import java.util.Map;
-import java.util.Set;
-import javax.lang.model.SourceVersion;
-import javax.tools.JavaFileObject;
-import javax.tools.JavaFileManager;
-import javax.tools.JavaFileManager.Location;
-import javax.tools.StandardJavaFileManager;
-
+import static com.sun.tools.javac.code.Flags.*;
+import static com.sun.tools.javac.code.Kinds.*;
+import static com.sun.tools.javac.code.TypeTags.CLASS;
+import static com.sun.tools.javac.jvm.ClassFile.*;
+import static com.sun.tools.javac.jvm.ClassFile.Version.*;
 import static javax.tools.StandardLocation.*;
 
-import com.sun.tools.javac.comp.Annotate;
 import com.sun.tools.javac.code.*;
-import com.sun.tools.javac.code.Type.*;
 import com.sun.tools.javac.code.Symbol.*;
-import com.sun.tools.javac.code.Symtab;
+import com.sun.tools.javac.code.Type.*;
+import com.sun.tools.javac.comp.Annotate;
 import com.sun.tools.javac.file.BaseFileObject;
+import com.sun.tools.javac.jvm.ClassFile.*;
+import com.sun.tools.javac.tree.*;
+import com.sun.tools.javac.tree.JCTree.*;
 import com.sun.tools.javac.util.*;
+import com.sun.tools.javac.util.List;
 
-import static com.sun.tools.javac.code.Flags.*;
-import static com.sun.tools.javac.code.Kinds.*;
-import static com.sun.tools.javac.code.TypeTags.*;
-import static com.sun.tools.javac.jvm.ClassFile.*;
-import static com.sun.tools.javac.jvm.ClassFile.Version.*;
+import java.io.*;
+import java.net.URI;
+import java.nio.CharBuffer;
+import java.util.*;
+
+import javax.lang.model.SourceVersion;
+import javax.tools.*;
+import javax.tools.JavaFileManager.Location;
 
 /** This class provides operations to read a classfile into an internal
  *  representation. The internal representation is anchored in a
@@ -124,6 +122,8 @@ public class ClassReader implements Completer {
 
     /** The name table. */
     final Names names;
+    
+    final TreeMaker treeMaker;
 
     /** Force a completion failure on this name
      */
@@ -233,6 +233,8 @@ public class ClassReader implements Completer {
         names = Names.instance(context);
         syms = Symtab.instance(context);
         types = Types.instance(context);
+        treeMaker = TreeMaker.instance(context);
+        
         fileManager = context.get(JavaFileManager.class);
         if (fileManager == null)
             throw new AssertionError("FileManager initialization error");
@@ -876,7 +878,8 @@ public class ClassReader implements Completer {
             // v45.3 attributes
 
             new AttributeReader(names.Code, V45_3, MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     if (readAllOfClassFile || saveParameterNames)
                         ((MethodSymbol)sym).code = readCode(sym);
                     else
@@ -885,7 +888,8 @@ public class ClassReader implements Completer {
             },
 
             new AttributeReader(names.ConstantValue, V45_3, MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     Object v = readPool(nextChar());
                     // Ignore ConstantValue attribute if field not final.
                     if ((sym.flags() & FINAL) != 0)
@@ -894,13 +898,15 @@ public class ClassReader implements Completer {
             },
 
             new AttributeReader(names.Deprecated, V45_3, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     sym.flags_field |= DEPRECATED;
                 }
             },
 
             new AttributeReader(names.Exceptions, V45_3, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     int nexceptions = nextChar();
                     List<Type> thrown = List.nil();
                     for (int j = 0; j < nexceptions; j++)
@@ -911,14 +917,16 @@ public class ClassReader implements Completer {
             },
 
             new AttributeReader(names.InnerClasses, V45_3, CLASS_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     ClassSymbol c = (ClassSymbol) sym;
                     readInnerClasses(c);
                 }
             },
 
             new AttributeReader(names.LocalVariableTable, V45_3, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     int newbp = bp + attrLen;
                     if (saveParameterNames) {
                         // pick up parameter names from the variable table
@@ -953,7 +961,8 @@ public class ClassReader implements Completer {
             },
 
             new AttributeReader(names.SourceFile, V45_3, CLASS_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     ClassSymbol c = (ClassSymbol) sym;
                     Name n = readName(nextChar());
                     c.sourcefile = new SourceFileObject(n, c.flatname);
@@ -961,7 +970,8 @@ public class ClassReader implements Completer {
             },
 
             new AttributeReader(names.Synthetic, V45_3, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     // bridge methods are visible when generics not enabled
                     if (allowGenerics || (sym.flags_field & BRIDGE) == 0)
                         sym.flags_field |= SYNTHETIC;
@@ -971,7 +981,8 @@ public class ClassReader implements Completer {
             // standard v49 attributes
 
             new AttributeReader(names.EnclosingMethod, V49, CLASS_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     int newbp = bp + attrLen;
                     readEnclosingMethodAttr(sym);
                     bp = newbp;
@@ -984,7 +995,8 @@ public class ClassReader implements Completer {
                     return super.accepts(kind) && allowGenerics;
                 }
 
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     if (sym.kind == TYP) {
                         ClassSymbol c = (ClassSymbol) sym;
                         readingClassAttr = true;
@@ -1013,31 +1025,36 @@ public class ClassReader implements Completer {
             // v49 annotation attributes
 
             new AttributeReader(names.AnnotationDefault, V49, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     attachAnnotationDefault(sym);
                 }
             },
 
             new AttributeReader(names.RuntimeInvisibleAnnotations, V49, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     attachAnnotations(sym);
                 }
             },
 
             new AttributeReader(names.RuntimeInvisibleParameterAnnotations, V49, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     attachParameterAnnotations(sym);
                 }
             },
 
             new AttributeReader(names.RuntimeVisibleAnnotations, V49, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     attachAnnotations(sym);
                 }
             },
 
             new AttributeReader(names.RuntimeVisibleParameterAnnotations, V49, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     attachParameterAnnotations(sym);
                 }
             },
@@ -1045,14 +1062,16 @@ public class ClassReader implements Completer {
             // additional "legacy" v49 attributes, superceded by flags
 
             new AttributeReader(names.Annotation, V49, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     if (allowAnnotations)
                         sym.flags_field |= ANNOTATION;
                 }
             },
 
             new AttributeReader(names.Bridge, V49, MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     sym.flags_field |= BRIDGE;
                     if (!allowGenerics)
                         sym.flags_field &= ~SYNTHETIC;
@@ -1060,13 +1079,15 @@ public class ClassReader implements Completer {
             },
 
             new AttributeReader(names.Enum, V49, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     sym.flags_field |= ENUM;
                 }
             },
 
             new AttributeReader(names.Varargs, V49, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     if (allowVarargs)
                         sym.flags_field |= VARARGS;
                 }
@@ -1074,13 +1095,15 @@ public class ClassReader implements Completer {
 
             // v51 attributes
             new AttributeReader(names.RuntimeVisibleTypeAnnotations, V49, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     attachTypeAnnotations(sym);
                 }
             },
 
             new AttributeReader(names.RuntimeInvisibleTypeAnnotations, V49, CLASS_OR_MEMBER_ATTRIBUTE) {
-                void read(Symbol sym, int attrLen) {
+                @Override
+		void read(Symbol sym, int attrLen) {
                     attachTypeAnnotations(sym);
                 }
             },
@@ -1486,6 +1509,9 @@ public class ClassReader implements Completer {
                 l.append(readAttributeValue());
             return new ArrayAttributeProxy(l.toList());
         }
+        case 'E':
+            JCExpression expr = readExpression();
+            return new Attribute.Expression(expr.type, expr);
         case '@':
             return readCompoundAnnotation();
         default:
@@ -1493,6 +1519,117 @@ public class ClassReader implements Completer {
         }
     }
 
+    private JCExpression readExpression() {
+	byte exprTag = nextByte();
+	switch (exprTag) {
+	case ClassFile.TREE_ArrayAccess: {
+	    Type type = readType(nextChar());
+	    JCExpression indexed = readExpression();
+	    JCExpression index = readExpression();
+	    return treeMaker.Indexed(indexed, index).setType(type);
+	}
+
+	case ClassFile.TREE_Binary: {
+	    Type type = readType(nextChar());
+	    int tag = nextInt();
+	    JCExpression lhs = readExpression();
+	    JCExpression rhs = readExpression();
+	    return treeMaker.Binary(tag, lhs, rhs).setType(type);
+	}
+
+	case ClassFile.TREE_Conditional: {
+	    Type type = readType(nextChar());
+	    JCExpression cond = readExpression();
+	    JCExpression truepart = readExpression();
+	    JCExpression falsepart = readExpression();
+	    return treeMaker.Conditional(cond, truepart, falsepart).setType(
+		    type);
+	}
+
+	case ClassFile.TREE_FieldAccess: {
+	    Type type = readType(nextChar());
+	    JCExpression selected = readExpression();
+	    Symbol sym = (Symbol) readPool(nextChar());
+	    return treeMaker.Select(selected, sym).setType(type);
+	}
+
+	case ClassFile.TREE_Ident: {
+	    Type type = readType(nextChar());
+	    Symbol sym = (Symbol) readPool(nextChar());
+	    return treeMaker.Ident(sym).setType(type);
+	}
+
+	case ClassFile.TREE_InstanceOf: {
+	    Type type = readType(nextChar());
+	    JCExpression expr = readExpression();
+	    JCExpression clazz = readExpression();
+	    return treeMaker.TypeTest(expr, clazz).setType(type);
+	}
+
+	case ClassFile.TREE_Literal: {
+	    Type type = readType(nextChar());
+	    int typetag = nextChar();
+	    Object value = readPool(nextChar());
+	    return treeMaker.Literal(typetag, value).setType(type);
+	}
+
+	case ClassFile.TREE_MethodInvocation: {
+	    Type type = readType(nextChar());
+	    JCExpression meth = readExpression();
+	    List<JCExpression> typeargs = readExpressions();
+	    List<JCExpression> args = readExpressions();
+	    return treeMaker.Apply(null, meth, args).setType(type);
+	}
+
+	case ClassFile.TREE_NewArray: {
+	    Type type = readType(nextChar());
+	    JCExpression elemtype = readExpression();
+	    List<JCExpression> dims = readExpressions();
+	    List<JCExpression> elems = readExpressions();
+	    return treeMaker.NewArray(elemtype, dims, elems).setType(type);
+	}
+
+	case ClassFile.TREE_NewClass: {
+	    Type type = readType(nextChar());
+	    JCExpression encl = readExpression();
+	    List<JCExpression> typeargs = readExpressions();
+	    JCExpression clazz = readExpression();
+	    List<JCExpression> args = readExpressions();
+	    return treeMaker.NewClass(encl, typeargs, clazz, args, null)
+		    .setType(type);
+	}
+
+	case ClassFile.TREE_TypeCast: {
+	    Type type = readType(nextChar());
+	    JCExpression clazz = readExpression();
+	    JCExpression expr = readExpression();
+	    return treeMaker.TypeCast(clazz, expr).setType(type);
+	}
+
+	case ClassFile.TREE_Unary: {
+	    Type type = readType(nextChar());
+	    int tag = nextChar();
+	    JCExpression arg = readExpression();
+	    return treeMaker.Unary(tag, arg).setType(type);
+	}
+
+	default:
+	    throw new AssertionError("unknown tree tag: " + exprTag);
+	}
+    }
+
+    private List<JCExpression> readExpressions() {
+	int numExpressions = nextChar();
+	ListBuffer<JCExpression> exprs = new ListBuffer<JCExpression>();
+	for (int i = 0; i < numExpressions; i++) {
+	    exprs.add(readExpression());
+	}
+	return exprs.toList();
+    }
+
+    /**
+     * TODO(spoon) this interface probably needs a method for expressions
+     */
     interface ProxyVisitor extends Attribute.Visitor {
         void visitEnumAttributeProxy(EnumAttributeProxy proxy);
         void visitArrayAttributeProxy(ArrayAttributeProxy proxy);
@@ -1507,7 +1644,8 @@ public class ClassReader implements Completer {
             this.enumType = enumType;
             this.enumerator = enumerator;
         }
-        public void accept(Visitor v) { ((ProxyVisitor)v).visitEnumAttributeProxy(this); }
+        @Override
+	public void accept(Visitor v) { ((ProxyVisitor)v).visitEnumAttributeProxy(this); }
         @Override
         public String toString() {
             return "/*proxy enum*/" + enumType + "." + enumerator;
@@ -1520,7 +1658,8 @@ public class ClassReader implements Completer {
             super(null);
             this.values = values;
         }
-        public void accept(Visitor v) { ((ProxyVisitor)v).visitArrayAttributeProxy(this); }
+        @Override
+	public void accept(Visitor v) { ((ProxyVisitor)v).visitArrayAttributeProxy(this); }
         @Override
         public String toString() {
             return "{" + values + "}";
@@ -1536,7 +1675,8 @@ public class ClassReader implements Completer {
             super(type);
             this.values = values;
         }
-        public void accept(Visitor v) { ((ProxyVisitor)v).visitCompoundAnnotationProxy(this); }
+        @Override
+	public void accept(Visitor v) { ((ProxyVisitor)v).visitCompoundAnnotationProxy(this); }
         @Override
         public String toString() {
             StringBuffer buf = new StringBuffer();
@@ -1673,6 +1813,10 @@ public class ClassReader implements Completer {
             throw new AssertionError(); // shouldn't happen
         }
 
+        public void visitExpression(Attribute.Expression expr) {
+            result = expr;
+        }
+
         public void visitError(Attribute.Error e) {
             throw new AssertionError(); // shouldn't happen
         }
@@ -2579,7 +2723,8 @@ public class ClassReader implements Completer {
         }
 
         /** @deprecated see bug 6410637 */
-        @Deprecated
+        @Override
+	@Deprecated
         public String getName() {
             return name.toString();
         }
